'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _svgprocessing = require('./svgprocessing');

var _svgprocessing2 = _interopRequireDefault(_svgprocessing);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var extend_vrv = function extend_vrv(svg) {
    // Make extensions to Verovio's SVG to facilitate user interaction

    var $svg = (0, _jquery2.default)(svg);

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = $svg.find("g.note, g.chord, g.rest, g.mRest")[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var el = _step.value;

            // skip events within chords
            if ((0, _jquery2.default)(el).parent().closest('g.chord').get(0)) {
                continue;
            }

            var $el = (0, _jquery2.default)(el);
            var g1_attrs = {
                "class": "cnt-selectable"
            };
            var g1 = _svgprocessing2.default.makeSVGEl("g", g1_attrs);

            var g2 = _svgprocessing2.default.makeSVGEl("g");

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = $el.children()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var child = _step3.value;

                    if ((0, _jquery2.default)(child).attr('class') == 'verse') {
                        (0, _jquery2.default)(g2).append(child);
                    } else {
                        (0, _jquery2.default)(g1).append(child);
                    }
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }

            $el.empty();
            $el.append(g1);
            $el.append(g2);
        }

        // Add some useful content to g.space
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
        for (var _iterator2 = $svg.find("g.space")[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            // console.log($(el).prevAll("*[x]"));
            // console.log($(el).prevAll("g"));
            // <text x="887" y="2390" dx="0" dy="0" text-anchor="end" font-size="0px">
            //             <tspan font-family="Garamond" font-size="405px">Altus</tspan>
            //         </text>

            var _el = _step2.value;
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
            }
        } finally {
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }

    return $svg.get(0);
};
exports.default = extend_vrv;